﻿using List_Text1.Data;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace List_Text1.Services
{
    public class ContatoService
    {
        public static List<Contato> GetContatos()
        {
            var lista = new List<Contato> {
                new Contato() {Id = 1, Nome = "Maria", Email = "maria@email.com", Telefone="13-8760-9909"},
                new Contato() {Id = 2, Nome = "Paulo", Email = "paulo@email.com", Telefone="12-9981-0919"},
                new Contato() {Id = 3, Nome = "Beatriz", Email = "bibi@yahoo.com", Telefone="11-9956-4098"},
                new Contato() {Id = 4, Nome = "Janice", Email = "jan@hotmail.com", Telefone="21-9850-0034"},
                new Contato() {Id = 5, Nome = "Mario", Email = "mario@email.com", Telefone="17-6580-1122"}
            };
            return lista;
        }

        public static bool SalvarListaParaTexto<T>(IEnumerable<T> lista, string arquivo,
           char separador)
        {
            try
            {
                using (var sw = File.CreateText(arquivo))
                {
                    var plist = typeof(T).GetProperties().Where(p => p.CanRead &&
                                (p.PropertyType.IsValueType || p.PropertyType == typeof(string))
                                && p.GetIndexParameters().Length == 0).ToList();

                    if (plist.Count > 0)
                    {
                        var seperator = separador.ToString();
                        sw.WriteLine(string.Join(seperator, plist.Select(p => p.Name)));
                        foreach (var item in lista)
                        {
                            var values = new List<object>();
                            foreach (var p in plist) values.Add(p.GetValue(item, null));
                            sw.WriteLine(string.Join(seperator, values));
                        }
                    }
                }
                return true;
            }
            catch 
            {
                throw;
            }
        }
        public static void ExibirArquivoTexto(string path)
        {
            if (File.Exists(path))
            {
                using (StreamReader sr = File.OpenText(path))
                {
                    string s = "";
                    while ((s = sr.ReadLine()) != null)
                    {
                        Console.WriteLine(s);
                    }
                }
            }
            else
            {
                Console.WriteLine($"Arquivo {path} não encontrado");
            }
        }
    }
}
