﻿using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace List_Text1.Services
{
    public static class ExtensionMethods
    {
        private static void SalvarListaParaTexto<T>(this IEnumerable<T> lista, string arquivo, 
            char separador)
        {
            using (var sw = File.CreateText(arquivo))
            {
                var plist = typeof(T).GetProperties().Where(p => p.CanRead &&
                            (p.PropertyType.IsValueType || p.PropertyType == typeof(string))
                            && p.GetIndexParameters().Length == 0).ToList();

                if (plist.Count > 0)
                {
                    var seperator = separador.ToString();
                    sw.WriteLine(string.Join(seperator, plist.Select(p => p.Name)));
                    foreach (var item in lista)
                    {
                        var values = new List<object>();
                        foreach (var p in plist) values.Add(p.GetValue(item, null));
                        sw.WriteLine(string.Join(seperator, values));
                    }
                }
            }
        }
    }
}